/*****************************************************************************
*
* Emrah Akin Sisbot
* Aug 10 
*
* File : sparkOro.h
* Brief: This file contains structures and functions for SPARK - Ontology link
*
******************************************************************************/

#ifndef SPARKORO_H
#define SPARKORO_H

#ifdef ORO

extern int connectOro (char *host, char *port);
void clearFacts();
extern int sendToORO(GEN_STRING64 address, GEN_STRING64 port);
extern int prepareFactsForORO(HRI_AGENTS * agents, HRI_ENTITIES * ents);
extern int printAllOroFacts(HRI_AGENTS * agents, HRI_ENTITIES * ents);
extern int reinitFactsForOROExportControl(HRI_AGENTS * agents, HRI_ENTITIES * ents);

extern int prepareAgentsActivityFactsForORO(HRI_AGENTS * agents, agents_activity_facts * agActivityFact ,int agActivityFactAgentIndex);
extern int printAgentsActivityFactsForORO(HRI_AGENTS * agents,int agActivityFactAgentIndex);
extern int reinitAgentsActivityFactsForOROExportControl(HRI_AGENTS * agents,int agActivityFactAgentIndex);
#endif
#endif
