/**
 ** sparkSituationAssessmentCodels.cc
 **
 ** Codels called by execution task sparkMainTask
 **
 ** Author: E. Akin Sisbot
 ** Date: Aug 10
 **
 **/

#include <portLib.h>

#include "server/sparkHeader.h"
#include "sparkm3d.h"

#ifdef ORO
#include "sparkOro.h"
#endif

#if defined(USE_MIGHTABILITY_MAPS)
extern agents_activity_facts Ag_Activity_Fact[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int STOP_AGENT_STATE_ANALYSIS;
extern int PRINT_AGENT_STATE_FACTS;
extern Agent_Activity_fact_by_names Hum_facts_by_name[MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int NewDataForASA;
extern int SHOW_OBJECT_FACTS;
extern int SHOW_OBJ_FACTS_BY_ARROW;
extern int OBJ_IS_VISIBLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK];
extern int OBJ_IS_REACHABLE_FOR_AGENT[MAXI_NUM_OF_ALLOWED_OBJECTS_IN_ENV][MAXI_NUM_OF_AGENT_FOR_HRI_TASK][MAXI_NUM_OF_HANDS_OF_AGENT];

#endif

// static SPARK_ALL_REACHABILITIES *gAllReachs = NULL;
// static SPARK_ALL_OBJECT_STATES *gPrevObjectStates = NULL;

/* ----------------- INTERNAL FUNCTIONS -------------------- */

// static int object_visibility_state(p3d_rob *object, HRI_AGENT *agent, 
// 				   double elevation, double azimuth,
// 				   int visThr,
// 				   SPARK_VISIBILITY *visibility)
// {
//   configPt sourceQ, savedQ;
//   p3d_rob * robot = NULL;
//   p3d_jnt *panJnt = NULL, *tiltJnt = NULL;
//   int visResult;
  
//   // MOVE THE AGENT TO LOOK AT THE TARGET
  
//   robot  = agent->robotPt;
//   panJnt  = robot->joints[agent->perspective->pan_jnt_idx];
//   tiltJnt = robot->joints[agent->perspective->tilt_jnt_idx];
 
  
//   if( (robot==NULL) || (panJnt==NULL) || (tiltJnt==NULL) ) {
//     printf("In %s:%d, bad input\n",__FILE__,__LINE__);
//     return FALSE;
//   }
  
//   sourceQ = MY_ALLOC(double, robot->nb_dof); /* ALLOC */
//   savedQ  = MY_ALLOC(double, robot->nb_dof); /* ALLOC */
  
//   p3d_get_robot_config_into(robot, &sourceQ);
//   p3d_get_robot_config_into(robot, &savedQ);
  
//   /* TURN PAN */
//   azimuth = azimuth + sourceQ[panJnt->index_dof]; // Relative to absolute angle

//   if(panJnt->dof_data[0].vmin > azimuth) {
//     if(panJnt->dof_data[0].vmax < azimuth - M_2PI) {
//       if(ABS(panJnt->dof_data[0].vmin-azimuth) < ABS(panJnt->dof_data[0].vmax-azimuth)) {
// 	sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmin;
//       }
//       else{
// 	sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmax;
//       } 
//     }
//     else{
//       sourceQ[panJnt->index_dof] = azimuth - M_2PI; 
//     }	
//   }
//   else{
//     if(panJnt->dof_data[0].vmax < azimuth) {
//       if(panJnt->dof_data[0].vmin > azimuth - M_2PI) {
// 	if(ABS(panJnt->dof_data[0].vmin-azimuth) < ABS(panJnt->dof_data[0].vmax-azimuth)) {
// 	  sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmin;
// 	}
// 	else{
// 	  sourceQ[panJnt->index_dof] = panJnt->dof_data[0].vmax;
// 	}
//       } 
//       else{
// 	sourceQ[panJnt->index_dof] = azimuth- M_2PI; 
//       }	
//     }
//     else{
//       sourceQ[panJnt->index_dof] = azimuth; 
//     }
//   } 
  
//   /* TURN TILT */
//   elevation = elevation + sourceQ[tiltJnt->index_dof]; // Relative to absolute angle
 
//   if(tiltJnt->dof_data[0].vmin > elevation) {
//     sourceQ[tiltJnt->index_dof] = tiltJnt->dof_data[0].vmin;
//   }
//   else{
//     if(tiltJnt->dof_data[0].vmax < elevation) {
//       sourceQ[tiltJnt->index_dof] = tiltJnt->dof_data[0].vmax;
//     }
//     else{
//       sourceQ[tiltJnt->index_dof] = elevation;  
//     }
//   }
  
//   p3d_set_and_update_this_robot_conf(robot, sourceQ);  
  
//   // VISIBILITY TEST
  
//   visResult = hri_is_object_visible(agent, object, visThr, FALSE, FALSE);

//   switch(visResult) {
//   case 0: // INVISIBLE
//     *visibility = INVISIBLE;
//     break;
//   case 1: // VISIBLE
//     *visibility = VISIBLE;
//     break;
//   }
//   p3d_set_and_update_this_robot_conf(robot, savedQ);
  
//   MY_FREE(savedQ, double, robot->nb_dof); /* FREE */
//   MY_FREE(sourceQ, double, robot->nb_dof); /* FREE */

//   return TRUE;
// }

// /* sparkIsVisibleMain  -  codel EXEC of IsVisible
//    Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkIsVisibleMain(SPARK_VISREACH_QUERY *visQuery, SPARK_VISREACH_RESULT *visResult, int *report)
// {
//   p3d_rob * target = NULL;
//   HRI_AGENT * sourceAgent = NULL;
//   int i;
//   double elevation = 0, azimuth = 0;
//   SPARK_VISIBILITY visibility;
//   int visibPl;


//   // -----Performance evaluation
//   //struct timeval tvBegin, tvEnd, tvDiff;
//   //gettimeofday(&tvBegin, NULL);
//   // -----

//   if(gAgents == NULL) {
//     *report = S_spark_NOT_INITIALIZED;
//     return ETHER;
//   }
  
//   // Find the target object
//   for(i=0; i<gEnv->nr; i++) {
//     if( strcasestr(gEnv->robot[i]->name, visQuery->target.name) ) {
//       target = gEnv->robot[i];
//       break;
//     }
//   }
//   if(target == NULL) {
//     *report = S_spark_OBJECT_NOT_FOUND;
//     return ETHER;
//   }
  
//   //Find the source agent
//   for(i=0; i<gAgents->all_agents_no; i++) {
//     if( strcasestr(gAgents->all_agents[i]->robotPt->name, visQuery->agent.name) ) {
//       sourceAgent = gAgents->all_agents[i];
//       break;
//     }
//   }
//   if(sourceAgent == NULL) {
//     *report = S_spark_AGENT_NOT_FOUND;
//     return ETHER;
//   }
  
//   hri_object_visibility_placement(sourceAgent, target, &visibPl, &elevation, &azimuth);
//   object_visibility_state(target, sourceAgent, elevation, azimuth, SPARK_DEFAULT_VISIBILITY_RATIO, &visibility);
  
//   switch((SPARK_VISIBILITY_PLACEMENT) visibPl) {
//   case FOA: //in FOA 
//     strcpy(visResult->result1.name,"FOA");
//     break;
//   case FOV: //in FOV 
//     strcpy(visResult->result1.name,"FOV");
//     break;
//   case OOF: //in OOF
//     strcpy(visResult->result1.name,"OOF");
//     break;
//   default: //should never come here
//     printf("Problem in visibility_placement\n");
//     break;
//   }
  
//   switch(visibility) {
//   case INVISIBLE:
//     strcpy(visResult->result2.name,"INVISIBLE");
//     break; 
//   case VISIBLE:
//     strcpy(visResult->result2.name,"VISIBLE");
//     break;
//   }

//   // -----Performance evaluation
//   //gettimeofday(&tvEnd, NULL);
//   //timeval_subtract(&tvDiff, &tvEnd, &tvBegin);
//   //printf("%ld.%06ld\n", tvDiff.tv_sec, tvDiff.tv_usec);
//   // -------
  
//   *report = OK;
//   return ETHER;
// }

// SPARK_REACHABILITY spark_object_reachability_state(p3d_rob * object, HRI_AGENT *agent)
// {
//   int reached = FALSE;
//   configPt qs, q;
//   p3d_vector3 Tcoord[3];
//   SPARK_REACHABILITY reachability;

//   // Target object
//   Tcoord[0][0] = object->joints[1]->abs_pos[0][3];      
//   Tcoord[0][1] = object->joints[1]->abs_pos[1][3];     
//   Tcoord[0][2] = object->joints[1]->abs_pos[2][3];
  
//   if(D3D(Tcoord[0][0],Tcoord[0][1],Tcoord[0][2],
// 	 agent->robotPt->joints[1]->abs_pos[0][3],
// 	 agent->robotPt->joints[1]->abs_pos[1][3],
// 	 agent->robotPt->joints[1]->abs_pos[2][3]) > 1.5) {
    
//     reachability = UNREACHABLE;
//   }

//   GIK_VIS = 500;
  
//   qs = MY_ALLOC(double, agent->robotPt->nb_dof); /* ALLOC */
//   q  = MY_ALLOC(double, agent->robotPt->nb_dof); /* ALLOC */
  
//   p3d_get_robot_config_into(agent->robotPt, &qs); /* Saving agent config */
  
//   reached = hri_agent_single_task_manip_move(agent, GIK_LATREACH, object, &q);
  
//   if(agent->manip->type == TWO_ARMED) {
//     p3d_set_and_update_this_robot_conf(agent->robotPt, qs);
//     reached = hri_agent_single_task_manip_move(agent, GIK_RATREACH, object, &q); 
//   }
//   p3d_set_and_update_this_robot_conf(agent->robotPt, q);
//   p3d_col_activate_robot(agent->robotPt);
  
//   // In the end of the motion check if there is a collision
//   if(!p3d_col_test_robot(agent->robotPt, 0)) {
//     // Check if the collision is with the object
//     p3d_col_deactivate_robot_robot(agent->robotPt, object);  
//     if(!p3d_col_test_robot(agent->robotPt, 0)) {
//       // The robot colliding another object
//       if(reached)
// 	reachability = REACHABLE_WITH_COLLISION;
//       else
// 	reachability = UNREACHABLE;
//     }
//     else {
//       // Robot collides only with the target
//       // That means it is reached
//       reachability = REACHABLE;
//     }
//     p3d_col_activate_robot_robot(agent->robotPt, object); 
//   }
//   else {
//     if(reached) {      
//       reachability = REACHABLE;
//     }
//     else {
//       reachability = UNREACHABLE;
//     }
//   }

//   p3d_set_and_update_this_robot_conf(agent->robotPt,qs);
  
//   MY_FREE(q, double , agent->robotPt->nb_dof); /* FREE */
//   MY_FREE(qs, double, agent->robotPt->nb_dof); /* FREE */
  
//   return reachability;
// }

// /* ----------------- END INTERNAL FUNCTIONS ----------------- */

/* sparkUpdateOneSituationAssessmentMain  -  codel EXEC of UpdateOneSituationAssessment
 
this function uses the same processing used in compute_geometric_facts of libhri. Onto update should be managed better.
*/
ACTIVITY_EVENT
sparkUpdateControlOneSituationAssessmentMain(SPARK_SPECIFIC_SA_PARAM *specificSAParam, int *report)
{
    int a_i,e_i,agentPartIndex;
  HRI_AGENT * agent = NULL;
  HRI_ENTITY * entity1 = NULL; 
  HRI_ENTITY * entity2 = NULL; 

  HRI_KNOWLEDGE_ON_ENTITY * kn_on_ent;
  //HRI_VISIBILITY * vis_result; 
  ENUM_HRI_VISIBILITY_PLACEMENT res;
  double elevation, azimuth;
  HRI_REACHABILITY reachability_result;
  HRI_SPATIAL_RELATION spatial_relation_result; 
  HRI_PLACEMENT_RELATION placement_relation_result;

  HRI_VISIBILITY * vis_result;

  if(gEnv == NULL || gAgents==NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }

  for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
    if(strcasestr(gAgents->all_agents[a_i]->robotPt->name, specificSAParam->agent.name)) {
      agent = gAgents->all_agents[a_i];
      break;
    }
  }
  if(agent == NULL) {
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
    if (!strcmp(specificSAParam->entity1.name, gEntities->entities[e_i]->name)) {     
      entity1 = gEntities->entities[e_i];
      kn_on_ent = &agent->knowledge->entities[e_i];
      break;
    }
  } 
  if(entity1 == NULL) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }


  /// Search for second entity only for processing type that needs it
  if(specificSAParam->updateControlType == SPARK_PLACEMENT_REL_PROC){
    for(e_i=0; e_i<gEntities->entities_nb; e_i++) {
      if (!strcmp(specificSAParam->entity2.name, gEntities->entities[e_i]->name)) {      
	entity2 = gEntities->entities[e_i];
	break;
      }
    } 
    if(entity2 == NULL) {
      *report = S_spark_SECOND_OBJECT_NOT_FOUND;
      return ETHER;
    }    
  }
  
  if(specificSAParam->updateControlType == SPARK_REACH_PROC ){	  
    // TODO: Fix this global variable use. It's ugly. 
    GIK_VIS = 500;
    reachability_result = hri_is_reachable(entity1, agent);	    
    if ( kn_on_ent->reachability ==  reachability_result) {
      if ( kn_on_ent->reachability_ischanged)
	kn_on_ent->reachability_ischanged = FALSE;
    }
    else {
      kn_on_ent->reachability = reachability_result;
      kn_on_ent->reachability_ischanged = TRUE;
      kn_on_ent->reachability_isexported = FALSE;
    }
  }
  else if(specificSAParam->updateControlType == SPARK_LOOKAT_PROC){
    // LOOKS AT / VISIBILITY PLACEMENT - FOV,FOA,OOF
    // TODO: visibility placement for robot parts	
    if(entity1->disappeared)
      res = HRI_UK_VIS_PLACE;
    else
      hri_entity_visibility_placement(agent, entity1, true, kn_on_ent->is_placed_from_visibility, &res, &elevation, &azimuth);

    // need to update is_exported , is_changed?
    kn_on_ent->is_placed_from_visibility = (HRI_VISIBILITY_PLACEMENT) res;
    vis_result = MY_ALLOC(HRI_VISIBILITY,1);
    g3d_compute_visibility_for_given_entities(&entity1, agent, vis_result, 1); 
    if ( kn_on_ent->visibility  ==  vis_result[0]) {
      if ( kn_on_ent->visibility_ischanged)
	kn_on_ent->visibility_ischanged  = FALSE;
    }
    else {
      kn_on_ent->visibility = vis_result[0];
      kn_on_ent->visibility_ischanged = TRUE;
      kn_on_ent->visibility_isexported = FALSE;
    }      
    MY_FREE(vis_result,HRI_VISIBILITY,1);

    if ( (((HRI_VISIBILITY_PLACEMENT) res) == HRI_FOA) && (kn_on_ent->visibility  == HRI_VISIBLE)) {
      if (kn_on_ent->is_looked_at != HRI_TRUE_V){
	kn_on_ent->is_looked_at = HRI_TRUE_V;
	kn_on_ent->is_looked_at_ischanged = TRUE;
	kn_on_ent->is_looked_at_isexported = FALSE;
      }	      	      
    }
    else {
      if (kn_on_ent->is_looked_at == HRI_TRUE_V){
	kn_on_ent->is_looked_at_ischanged = TRUE;
	kn_on_ent->is_looked_at_isexported = FALSE;
      }	 
      if( (res == HRI_UK_VIS_PLACE) || (kn_on_ent->visibility  == HRI_UK_VIS))
	kn_on_ent->is_looked_at = HRI_UK_V;
      else
	kn_on_ent->is_looked_at = HRI_FALSE_V;
    }
    
  }
  else if(specificSAParam->updateControlType ==  SPARK_DELETE_DIVERGENT_POSITION){
      hri_delete_agent_entity_divergent_position(agent,e_i);
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_KNOWS_POSITION){
      if(!kn_on_ent->hasEntityPositionKnowledge){	  
	  kn_on_ent->hasEntityPositionKnowledge = true;
	  agent->knowledge->numUnknownPositions--;
      }
  }
  else if(specificSAParam->updateControlType ==  SPARK_FORCE_AGENT_DOESNT_KNOW_POSITION){
      if(kn_on_ent->hasEntityPositionKnowledge){	  
	  kn_on_ent->hasEntityPositionKnowledge = false;
	  agent->knowledge->numUnknownPositions++;
	  if(kn_on_ent->hasEntityPosition){
	      kn_on_ent->hasEntityPosition = false;
	      MY_FREE(kn_on_ent->entityPositionForAgent, double, kn_on_ent->entPt->robotPt->nb_dof);
	      agent->knowledge->numDivergentPositions--;
	  }
      }
  }
  else if((specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO) || (specificSAParam->updateControlType ==  SPARK_STOP_MANAGE_DISTANCE_INFO)){
      agentPartIndex = specificSAParam->agentPartIndex;
      if((agentPartIndex < -1) || (agentPartIndex >= agent->hand_nb)){
	  *report = S_spark_AGENT_PART_NOT_FOUND;
	  return ETHER;
      }
      else{
	  if(specificSAParam->updateControlType ==  SPARK_START_MANAGE_DISTANCE_INFO)
	      hri_add_agent_entity_distance_management(agent,agentPartIndex,e_i);
	  else
	      hri_delete_agent_entity_distance_management(agent,agentPartIndex,e_i);
      }
  }
  else{
    *report = S_spark_UNMANAGED_TYPE;
    return ETHER;
  }


  *report = OK;
  return ETHER;
}

/* sparkUpdateAllSAMain  -  codel EXEC of UpdateAllSituationAssessment
  this function will force or inhibit the update of situation assessement
*/
// request used to force reprocessing, to print value or update some parameters values, ...
ACTIVITY_EVENT
sparkUpdateAllSAMain( SPARK_SA_UPDATE_PARAM *updateAllSAParam, int *report)
{
  if(gEntities == NULL) {
    *report = S_spark_NOT_INITIALIZED;
    return ETHER;
  }
  if( updateAllSAParam->type == SPARK_UPDATE_ALL){
    gEntities->needSituationAssessmentUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_LOOK_AT){
    gEntities->needLooksatUpdate = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_BLOCK_UPDATE_ALL){
    gEntities->isWorldStatic = FALSE;
    gEntities->forbidWorldStatic = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_DEBLOCK_UPDATE_ALL){
    gEntities->forbidWorldStatic = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_ALL_UPDATE){
    SDI_F->state.oroPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_ALL_SPARK_ORO){
#ifdef ORO 
   printAllOroFacts(gAgents, gEntities); 
#if defined(USE_MIGHTABILITY_MAPS)
   printAgentsActivityFactsForORO(gAgents,HUMAN1_MA);
#endif
#endif
  }
  else if( updateAllSAParam->type == SPARK_REEXPORT_ALL_SPARK_ORO){
#ifdef ORO 
    clearFacts(); 
    reinitFactsForOROExportControl(gAgents, gEntities); 
    prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
    reinitAgentsActivityFactsForOROExportControl(gAgents,HUMAN1_MA);
    prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
    sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_ON){
    gEntities->printVisibilityImages = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_CREATE_VISIBILITY_IMAGES_OFF){
    gEntities->printVisibilityImages = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_ALLOW_DISAPPEAR){
    gEntities->general_allow_disappear = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_FOREBID_DISAPPEAR){
    gEntities->general_allow_disappear = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_PRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = TRUE;
  }
  else if( updateAllSAParam->type == SPARK_NOPRINT_VIMAN_INPUT){
    SDI_F->state.vimanPrintEnabled = FALSE;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_REACHABILITY_DISTANCE){    
    gEntities->needToUpdateParameters = TRUE;   
    gEntities->numParameterToUpdate = 0;
    gEntities->hackedReachabilityDistance = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NOT_STATIC_WITHOUT_RECOMPUTATION_ITER_MAX){ 
      gEntities->maxWorldNotStaticBeforeRecompute = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_NO_EVENT_STEPS_BEFORE_STATIC_ITER_MIN){ 
      gEntities->lastEventsInTheWorldStepsMin = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_DISAPEAR_ITER_MAX){
    gEntities->needToUpdateParameters = TRUE;   
    gEntities->numParameterToUpdate = 1;
    gEntities->maxUnexplainedUndetectionIter = updateAllSAParam->intUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_IS_ON_MAX_DIST){    
    gEntities->needToUpdateParameters = TRUE;
    gEntities->numParameterToUpdate = 2;
    gEntities->isOnThreshold = updateAllSAParam->doubleUpdatedValue;
  }
  else if( updateAllSAParam->type == SPARK_UPDATE_AVERAGE_MOTION_EXPORT_THRESHOLD){    
    gEntities->averageDistanceScoreExportThreshold = updateAllSAParam->doubleUpdatedValue;
  }

  else if( updateAllSAParam->type == SPARK_SWITCH_PRINT_SA_RECOMPUTE_STATUS){ 
    if(gEntities->printSARecomputeStatus) {
      gEntities->printSARecomputeStatus=FALSE;
      printf("stop printing SA status\n");   
      }
    else{
      gEntities->printSARecomputeStatus=TRUE;
      printf("start printing SA status\n");   
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DISPLAY_SA_RECOMPUTE_STATUS){ 
    if(gEntities->displaySARecomputeStatus) {
      gEntities->displaySARecomputeStatus=false;
      printf("stop displaying SA status\n");   
      }
    else{
      gEntities->displaySARecomputeStatus=true;
      printf("start displaying SA status\n");   
    }
  }
  else if( updateAllSAParam->type == SPARK_SWITCH_DRAW_ACTION_MONITORING_SPHERES){ 
    if(gSpheres->drawSpheres){
      printf("stop drawing monitoring spheres\n"); 
      gSpheres->drawSpheres = FALSE;
    }
    else{
      printf("start drawing monitoring spheres\n"); 
      gSpheres->drawSpheres = TRUE; 
      gSpheres->drawSpheresOpacity = updateAllSAParam->doubleUpdatedValue;
    }
  }
  else if( updateAllSAParam->type == SPARK_ENABLE_DIVERGENT_POSITION){
      gEntities->manageDivergentBeliefs = true;
  }
  else if( updateAllSAParam->type == SPARK_DISABLE_DIVERGENT_POSITION){
      gEntities->manageDivergentBeliefs = false;
  }  
  else {
    *report = S_spark_UNKNOWN_UPDATE_TYPE;
    return ETHER;
  }
  

  *report = OK;
  return ETHER;
}

// static SPARK_PLACEMENT_RELATION placement_relation(p3d_rob *sourceObj, p3d_rob *targetObj)
// {
//   double sourceObjCx, sourceObjCy, sourceObjCz, targetObjCx, targetObjCy, targetObjCz;
//   int nextTo = FALSE;
  
//   if(sourceObj == NULL || targetObj == NULL) {
//     printf("%s:%d plrelation input is null",__FILE__,__LINE__);
//     return NOPLR;
//   }
  
//   sourceObjCx = (sourceObj->BB.xmin + sourceObj->BB.xmax)/2;
//   sourceObjCy = (sourceObj->BB.ymin + sourceObj->BB.ymax)/2;
//   sourceObjCz = (sourceObj->BB.zmin + sourceObj->BB.zmax)/2;
  
//   targetObjCx = (targetObj->BB.xmin + targetObj->BB.xmax)/2;
//   targetObjCy = (targetObj->BB.ymin + targetObj->BB.ymax)/2;
//   targetObjCz = (targetObj->BB.zmin + targetObj->BB.zmax)/2;
  
//   /* Compute IN */
  
//   /* Test if source Obj is in targetObj */
//   /* Condition: Source Obj BB should be wholly in targetObj BB */ 
  
//   if((targetObj->BB.xmin <= sourceObj->BB.xmin) && (targetObj->BB.xmax >= sourceObj->BB.xmax) &&
//      (targetObj->BB.ymin <= sourceObj->BB.ymin) && (targetObj->BB.ymax >= sourceObj->BB.ymax) &&
//      (targetObj->BB.zmin <= sourceObj->BB.zmin) && (targetObj->BB.zmax >= sourceObj->BB.zmax)) {
//     return ISIN;
//   }
  
//   /* Compute ON */
  
//   /* Test if sourceObj is on targetObj */
//   /* Condition 1: The center of SourceObj BB should be in the x,y limits of targetObj BB */
//   /* Condition 2: The lower part of SourceObj BB should either intersect with the upper part of targetObj BB */ 
//   /*              or there should be few cm's */ 
  
  
//   if((sourceObjCx >= targetObj->BB.xmin) && (sourceObjCx <= targetObj->BB.xmax) &&
//      (sourceObjCy >= targetObj->BB.ymin) && (sourceObjCy <= targetObj->BB.ymax) &&
//      (sourceObjCz >= targetObj->BB.zmax)) {
    
//     if( ABS(sourceObjCz-sourceObj->BB.zmin)*1.2 >= ABS(sourceObjCz-targetObj->BB.zmax)) {
//       return ISON;
//     }
//   }
  
//   /* Compute NEXT */
  
//   /* Test if sourceObj is next to targetObj */
//   /* Condition 1: The Z values of sourceObj and targetObj BB's should intersect = One should not be wholly above the other */
//   /* Condition 2: Distance(sourceObj,targetObj) should be less then a constant */
  
//   if ( !(sourceObj->BB.zmax <= targetObj->BB.zmin || sourceObj->BB.zmin >= targetObj->BB.zmax) ) {
//     if(D2D(sourceObjCx,sourceObjCy,targetObjCx,targetObjCy) < 
//        MAX(ABS(sourceObj->BB.xmin-sourceObj->BB.xmax),ABS(sourceObj->BB.ymin-sourceObj->BB.ymax)) &&
//        D2D(sourceObjCx,sourceObjCy,targetObjCx,targetObjCy) > 
//        MAX(ABS(sourceObj->BB.xmin-sourceObj->BB.xmax)/2,ABS(sourceObj->BB.ymin-sourceObj->BB.ymax)/2)) {
      
//       nextTo = TRUE;
//       return ISNEXTTO;
//     }
//   }
  
//   if(!nextTo) {
//     if ( !(targetObj->BB.zmax <= sourceObj->BB.zmin || targetObj->BB.zmin >= sourceObj->BB.zmax) ) {
//       if(D2D(sourceObjCx,sourceObjCy,targetObjCx,targetObjCy) < 
// 	 MAX(ABS(targetObj->BB.xmin-targetObj->BB.xmax),ABS(targetObj->BB.ymin-targetObj->BB.ymax)) &&
// 	 D2D(sourceObjCx,sourceObjCy,targetObjCx,targetObjCy) > 
// 	 MAX(ABS(targetObj->BB.xmin-targetObj->BB.xmax)/2,ABS(targetObj->BB.ymin-targetObj->BB.ymax)/2)) {
	
// 	nextTo = TRUE;
// 	return ISNEXTTO;
//       }
//     }
//   }
  
//   return NOPLR;  
// } 

// static SPARK_SPATIAL_RELATION spatial_relation(p3d_rob * object, p3d_rob * robot)
// {
//   p3d_vector4 targetRealCoord;
//   p3d_vector4 targetRelativeCoord;
//   p3d_matrix4 inv;
//   double rho, phi, theta;
//   int isFar;
//   double frontAngle = 0.26; //TODO: Make this changeable
  
//   if( (robot == NULL) || (object == NULL) ) {
//     return NO_RELATION;  
//   }
  
//   targetRealCoord[0] = object->joints[1]->abs_pos[0][3];
//   targetRealCoord[1] = object->joints[1]->abs_pos[1][3];
//   targetRealCoord[2] = object->joints[1]->abs_pos[2][3];
//   targetRealCoord[3] = 1;
  
//   p3d_matInvertXform(robot->joints[1]->abs_pos, inv);
  
//   p3d_matvec4Mult(inv, targetRealCoord, targetRelativeCoord);
  
//   p3d_cartesian2spherical(targetRelativeCoord[0],targetRelativeCoord[1],targetRelativeCoord[2],
// 			  &rho, &theta, &phi);
  

//   isFar = (SPARK_FAR_LIMIT < D2D(targetRelativeCoord[0],targetRelativeCoord[1],0,0));
  
//   //  printf("real coord %f %f %f\n",targetRealCoord[0],targetRealCoord[1],targetRealCoord[2]);
//   //  printf("relative coord %f %f %f\n",targetRelativeCoord[0],targetRelativeCoord[1],targetRelativeCoord[2]);
//   //  printf("Phi is %f, isFar is %d\n",phi,isFar);
  
//   /* Phi is the horizontal one */
  
//   if(ABS(phi) < frontAngle) { /* In front */
//     if(isFar) return FAR_FRONT ;
//     else   return  NEAR_FRONT ;
//   }
//   if(frontAngle <= phi && phi < 3*M_PI/8) { /* Front left */
//     if(isFar)  return  FAR_FRONT_LEFT ;
//     else   return NEAR_FRONT_LEFT ;
//   }
//   if(3*M_PI/8 <= phi && phi < 5*M_PI/8) { /* left */ 
//     if(isFar)   return FAR_LEFT ;
//     else    return NEAR_LEFT ;
//   }
//   if(5*M_PI/8 <= phi && phi < 7*M_PI/8) { /* Back left */
//     if(isFar)  return  FAR_BACK_LEFT ;
//     else   return NEAR_BACK_LEFT ;
//   }
//   if(7*M_PI/8 <= ABS(phi)) { /* Back */
//     if(isFar)  return  FAR_BACK ;
//     else   return  NEAR_BACK ;
//   }
//   if(-7*M_PI/8 <= phi && phi < -5*M_PI/8) { /* Back right */
//     if(isFar)  return FAR_BACK_RIGHT ;
//     else  return NEAR_BACK_RIGHT ;
//   }
//   if(-5*M_PI/8 <= phi && phi < -3*M_PI/8) { /* right */
//     if(isFar) return FAR_RIGHT ;
//     else   return NEAR_RIGHT ;
//   }
//   if(-3*M_PI/8 <= phi && phi < -1*frontAngle) { /* Front right */
//     if(isFar)  return FAR_FRONT_RIGHT ;
//     else   return NEAR_FRONT_RIGHT ;
//   }
//   printf("Bad angle value, This shouldn't happen.\n");
  
//   return NO_RELATION;
// }

// /* sparkUpdateObjectsStatesStart  -  codel START of UpdateObjectsStates
//    Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkUpdateObjectsStatesStart(int *report)
// {
//   gPrevObjectStates = MY_ALLOC(SPARK_ALL_OBJECT_STATES, 1); /* ALLOC */
  
//   return EXEC;
// }

// /* sparkUpdateObjectsStatesMain  -  codel EXEC of UpdateObjectsStates
//    Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkUpdateObjectsStatesMain(int *report)
// {
//   SPARK_VISIBILITY objRobotVis, objAgentVis;
//   int objRobotVisPl, objAgentVisPl;
//   SPARK_REACHABILITY objRobotReach, objHumanReach;
//   int pointingResult = FALSE;
//   configPt objectQ;
//   int i, j, agent_i, agent_j;
//   double elevation = 0, azimuth = 0;
//   int plRelationIndex = 0;
//   SPARK_PLACEMENT_RELATION plrelation;
//   HRI_AGENT *current_agent = NULL;

//   if(SDI_F->updateObjectsStates == FALSE) {
//     return EXEC;
//   }

//   memcpy(gPrevObjectStates, &SDI_F->objStates, sizeof(SPARK_ALL_OBJECT_STATES));

//   for(i=0; i<gEnv->nr; i++) { // For all objects in SPARK
    
//     if(!strcmp(SDI_F->objStates.object[i].name.name,"NOT_VALID_OBJECT"))
//       continue;

//     // find visibility placement for robot
//     hri_object_visibility_placement(gAgents->robots[0], gEnv->robot[i], &objRobotVisPl, &elevation, &azimuth);
    
//     if ( (SPARK_VISIBILITY_PLACEMENT)objRobotVisPl != OOF ) {
      
//       object_visibility_state(gEnv->robot[i], gAgents->robots[0], elevation, azimuth, 50, &objRobotVis);
     
//       if( objRobotVis == VISIBLE && !SDI_F->objStates.object[i].detected && !strcasestr(gEnv->robot[i]->name,"TABLE") &&
// 	  (SDI_F->state.vimanPosterAv || SDI_F->state.sparkObjPosPosterAv) ) {
// 	// Object has dissappeared	
// 	objectQ = MY_ALLOC(double, gEnv->robot[i]->nb_dof); /* ALLOC */
// 	p3d_get_robot_config_into(gEnv->robot[i], &objectQ);
// 	objectQ[6] = objectQ[7] = objectQ[8] = 0;      
// 	p3d_set_and_update_this_robot_conf(gEnv->robot[i], objectQ);
// 	MY_FREE(objectQ, double, gEnv->robot[i]->nb_dof); /* FREE */
// 	SDI_F->objStates.object[i].disappeared = TRUE;
// #ifdef ORO
// 	updateObject(&SDI_F->objStates.object[i], &gPrevObjectStates->object[i]);
// #endif	
// 	continue; // We pass to the next object
//       }
      
//       SDI_F->objStates.object[i].disappeared = FALSE;
//       strcpy(SDI_F->objStates.object[i].agentVisibilityState[0].agentName.name, gAgents->all_agents[0]->robotPt->name);
//       SDI_F->objStates.object[i].agentVisibilityState[0].visibility = objRobotVis;
//       SDI_F->objStates.object[i].agentVisibilityState[0].visibilityPlacement = (SPARK_VISIBILITY_PLACEMENT) objRobotVisPl;
      
//       SDI_F->objStates.object[i].agentVisibilityState[0].spatialRelation = spatial_relation(gEnv->robot[i], gAgents->all_agents[0]->robotPt);
      
//       SDI_F->objStates.object[i].agentVisibilityStateNb = 1;
            
//       // Agent Visibility and spatial relations
      
//       for(agent_i = 1; agent_i<gAgents->all_agents_no; agent_i++) {
	
// 	current_agent = gAgents->all_agents[agent_i];
	
// 	hri_object_visibility_placement(current_agent, gEnv->robot[i], &objAgentVisPl, &elevation, &azimuth);
// 	object_visibility_state(gEnv->robot[i], current_agent, elevation, azimuth, 50, &objAgentVis);
		
// 	strcpy(SDI_F->objStates.object[i].agentVisibilityState[agent_i].agentName.name,current_agent->robotPt->name);
// 	SDI_F->objStates.object[i].agentVisibilityState[agent_i].visibility = objAgentVis;
// 	SDI_F->objStates.object[i].agentVisibilityState[agent_i].visibilityPlacement = (SPARK_VISIBILITY_PLACEMENT) objAgentVisPl;
	
// 	// -----Pointing
// 	hri_object_pointing_placement(current_agent, gEnv->robot[i], &objAgentVisPl, &elevation, &azimuth);
// 	if((SPARK_VISIBILITY_PLACEMENT) objAgentVisPl == FOA) {
// 	  pointingResult = hri_is_object_pointed(current_agent,  gEnv->robot[i], 50, FALSE);
// 	  if(pointingResult == TRUE)
// 	    SDI_F->objStates.object[i].agentVisibilityState[agent_i].pointedAt = TRUE;
// 	  else
// 	    SDI_F->objStates.object[i].agentVisibilityState[agent_i].pointedAt = FALSE;
// 	}
// 	else {
// 	  SDI_F->objStates.object[i].agentVisibilityState[agent_i].pointedAt = FALSE;
// 	}
// 	// -----
// 	SDI_F->objStates.object[i].agentVisibilityState[agent_i].spatialRelation = spatial_relation(gEnv->robot[i], current_agent->robotPt);
	
// 	SDI_F->objStates.object[i].agentVisibilityStateNb++;
//       }

//       // Reachability computation is transfered to computeAllRechabilities Request
//       //objRobotReach = spark_object_reachability_state(gEnv->robot[i], gAgents->robots[0]);
//       //SDI_F->objStates.object[i].robotReachability = objRobotReach;
      
//       //objHumanReach = spark_object_reachability_state(gEnv->robot[i], gAgents->humans[0]);
//       //SDI_F->objStates.object[i].humanReachability = objHumanReach;
      
//       SDI_F->objStates.object[i].pos.x = gEnv->robot[i]->joints[1]->abs_pos[0][3];
//       SDI_F->objStates.object[i].pos.y = gEnv->robot[i]->joints[1]->abs_pos[1][3];
//       SDI_F->objStates.object[i].pos.z = gEnv->robot[i]->joints[1]->abs_pos[2][3];

//       // Compute Object spatial placement
//       plRelationIndex = 0;
//       for(j=0; j<gEnv->nr; j++) { // For all objects in SPARK
// 	if(i!=j && ( SDI_F->objStates.object[j].detected || strcasestr(gEnv->robot[j]->name,"TABLE") ) ) {
// 	  // we compute relative placements only with detected objects
// 	  plrelation =  placement_relation(gEnv->robot[i],gEnv->robot[j]);
	  
// 	  if(plrelation != NOPLR) {
// 	    SDI_F->objStates.object[i].placements[plRelationIndex].relation = plrelation;
// 	    strcpy(SDI_F->objStates.object[i].placements[plRelationIndex].object.name, gEnv->robot[j]->name);
// 	    plRelationIndex++;
// 	  }
// 	}
//       }

//       SDI_F->objStates.object[i].placementLength = plRelationIndex; 

//       //printf("Info computed for %s - %d\n", gEnv->robot[i]->name, time(0));

// #ifdef ORO
//       updateObject(&SDI_F->objStates.object[i], &gPrevObjectStates->object[i] );
// #endif
//     }
//   }
// #ifdef ORO 
//   // Agent related stuff 
//   for(agent_i = 0; agent_i<gAgents->all_agents_no; agent_i++) {
   
//     for(agent_j = 0; agent_j<gAgents->all_agents_no; agent_j++) {

//       updateAgentPosture(gAgents->all_agents[agent_i], agent_i, (SPARK_HUMAN_STATE_ENUM)gAgents->all_agents[agent_i]->actual_state);
//       updateAgentPosture(gAgents->all_agents[agent_i], agent_j, (SPARK_HUMAN_STATE_ENUM)gAgents->all_agents[agent_i]->actual_state);

//       if(agent_i != agent_j) {
// 	updateAgentSp(agent_i, gAgents->all_agents[agent_j], spatial_relation(gAgents->all_agents[agent_j]->robotPt, gAgents->all_agents[agent_i]->robotPt));
	
// 	hri_object_visibility_placement(gAgents->all_agents[agent_i], gAgents->all_agents[agent_j]->robotPt, &objAgentVisPl, &elevation, &azimuth);
// 	object_visibility_state(gAgents->all_agents[agent_j]->robotPt,gAgents->all_agents[agent_i] , elevation, azimuth, 50, &objAgentVis);	
	
// 	updateAgentAgentVisibility(gAgents->all_agents[agent_i],agent_i, gAgents->all_agents[agent_j],
// 				   (SPARK_VISIBILITY_PLACEMENT)objAgentVisPl, objAgentVis);
// 	updateAgentAgentVisibility(gAgents->all_agents[agent_i],agent_j, gAgents->all_agents[agent_j],
// 				   (SPARK_VISIBILITY_PLACEMENT)objAgentVisPl, objAgentVis);
//       }
//     }
//   }
// #endif
  
//   sparkObjectStatesobjStatesPosterWrite(SPARK_OBJECTSTATES_POSTER_ID, &SDI_F->objStates);

// #ifdef ORO  
//   sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
// #endif
  
//   SDI_F->updateObjectsStates = FALSE;
  
//   return EXEC;
// }

/* sparkUpdateObjectsStatesEnd  -  codel END of UpdateObjectsStates
   Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkUpdateObjectsStatesEnd(int *report)
// {
//   MY_FREE(gPrevObjectStates, SPARK_ALL_OBJECT_STATES, 1); /* ALLOC */
//   printf("Object State Update is stopped\n");
//   *report = OK;
//   return ETHER;
// }

/* sparkUpdateObjectsStatesInter -  codel INTER of UpdateObjectsStates
   Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkUpdateObjectsStatesInter(int *report)
// {
//   MY_FREE(gPrevObjectStates, SPARK_ALL_OBJECT_STATES, 1); /* ALLOC */
//   printf("Object State Update is stopped\n");
//   *report = OK;
//   return ETHER;
// }

// /* sparkComputeAllReachabilitiesMain  -  codel EXEC of ComputeAllReachabilities
//    Returns:  EXEC END ETHER FAIL ZOMBIE */
// ACTIVITY_EVENT
// sparkComputeAllReachabilitiesMain(int *report)
// {
//   int i,j;
//   int agentReachIdx = 0;
  
//   if(gAllReachs == NULL) {
//     gAllReachs = MY_ALLOC(SPARK_ALL_REACHABILITIES, 1);
//     gAllReachs->agentReach = MY_ALLOC(SPARK_AGENT_REACHABILITY, gAgents->all_agents_no * (gEnv->nr - 1));
//     gAllReachs->agentReachNb = gAgents->all_agents_no * (gEnv->nr - 1);
//   }
  
//   for(i=0; i<gAgents->all_agents_no; i++) {
//     for(j=0; j<gEnv->nr; j++) {

//       // No need to check self reachability :-)
//       if(gEnv->robot[j] != gAgents->all_agents[i]->robotPt) {
	
// 	// Check if j'th object is a valid one
// 	if(strcmp(SDI_F->objStates.object[j].name.name,"NOT_VALID_OBJECT")) {
	  
// 	  strcpy(gAllReachs->agentReach[agentReachIdx].agentName.name,
// 		 gAgents->all_agents[i]->robotPt->name);
// 	  strcpy(gAllReachs->agentReach[agentReachIdx].objectName.name,
// 		 gEnv->robot[j]->name);
// 	  if(!SDI_F->objStates.object[j].exists || SDI_F->objStates.object[j].disappeared) 
// 	    gAllReachs->agentReach[agentReachIdx].reachability = REACHABILITY_UNKNOWN;
// 	  else
// 	    gAllReachs->agentReach[agentReachIdx].reachability = spark_object_reachability_state(gEnv->robot[j], gAgents->all_agents[i]);		      
	  
// 	  printf("Agent Name: %s Object name: %s REACHABILITY: %d\n", 
// 		 gAllReachs->agentReach[agentReachIdx].agentName.name,
// 		 gAllReachs->agentReach[agentReachIdx].objectName.name,
// 		 gAllReachs->agentReach[agentReachIdx].reachability);
	  
// 	  gAllReachs->agentReachNb = ++agentReachIdx;
// 	}
//       }
//     }
//   }
  
// #ifdef ORO
//   sendReachabilitiesToORO(gAllReachs, SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
// #endif 
  
//   return ETHER;
// }


int setAgActivtitySituationAssessmentUpdateNeeds(int for_agent)
{

#if defined(USE_MIGHTABILITY_MAPS)
  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);
    
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode); 
#endif
}

int decideSituationAssessmentAgentRelatedUpdate(int agentIndex){
  int eventsInTheWorld = FALSE;
  int needSituationAssessmentUpdate = FALSE;
  int needLooksatUpdate = FALSE;
  
  ///Whole Body and Torso and hand move (in manipulation mode) require to recompute ALL

  ///Head Move require to recompute only look at

  ///All other move than head imply eventsInTheWorld FALSE.

#if defined(USE_MIGHTABILITY_MAPS)
  if((Ag_Activity_Fact[agentIndex].whole_body == AGENT_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].whole_body == AGENT_MOVING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
    //printf("Agent %d moving %d \n",agentIndex,Ag_Activity_Fact[agentIndex].whole_body);
  }

  if((Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].torso == AGENT_TORSO_TURNING) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].right_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].right_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if(((Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_HAS_MOVED) || (Ag_Activity_Fact[agentIndex].left_hand == AGENT_HAND_MOVING)) && (Ag_Activity_Fact[agentIndex].left_hand_mode == AGENT_HAND_AT_MANIPULATION_MODE) ){
    eventsInTheWorld = TRUE;
    needSituationAssessmentUpdate = TRUE;
  }

  if((Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_HAS_TURNED) || (Ag_Activity_Fact[agentIndex].head == AGENT_HEAD_TURNING) ){
    needLooksatUpdate = TRUE;
  }
#endif
  if(eventsInTheWorld)
    gEntities->eventsInTheWorld = TRUE;
  if(needSituationAssessmentUpdate)
    gEntities->needSituationAssessmentUpdate = TRUE;
  if(needLooksatUpdate)
    gEntities->needLooksatUpdate = TRUE;

  return TRUE;
} 


int feedVisReachVisualisationStruct(int agentIndex){
  int a_i,e_i,agent_index;

#if defined(USE_MIGHTABILITY_MAPS)

  if(gAgents == NULL || gEnv == NULL || gEntities == NULL) {
    return FALSE;
  }  
  
  if (SHOW_OBJECT_FACTS == 1){
    for(a_i=0; a_i<gAgents->all_agents_no; a_i++) {
      agent_index = Ag_Activity_Fact[agentIndex].agent_index;
      if( agent_index >= 0){
	if( strcasestr(gAgents->all_agents[a_i]->robotPt->name,gEnv->robot[agent_index]->name)){
	  for(int e_i=0; e_i<gEntities->entities_nb; e_i++) {
	    if((gEntities->entities[e_i]->subtype == HRI_MOVABLE_OBJECT) && gEntities->entities[e_i]->is_present){
	  
	      if (gAgents->all_agents[a_i]->knowledge->entities[e_i].visibility == HRI_VISIBLE)
		OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 1;
	      else
		OBJ_IS_VISIBLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex]= 0;

	      if (gAgents->all_agents[a_i]->knowledge->entities[e_i].reachability == HRI_REACHABLE)
		OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 1;	
	      else
		OBJ_IS_REACHABLE_FOR_AGENT[gEntities->entities[e_i]->indexInEnv][agentIndex][0]= 0;	
	    }
	  }
	  break;
	}      
      }
    }
  }

#endif
  
  return TRUE;
} 


/* sparkComputeFactsStart  -  codel START of ComputeFacts
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsStart(int *report)
{  
  return EXEC;
}


/* sparkComputeFactsMain  -  codel EXEC of ComputeFacts
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsMain(int *report)
{ 
  if (gAgents == NULL) return EXEC;
  
  float clock_val = 0;
  float elapsed_time = 0;
  
  //clock_val = clock();
#if defined(USE_MIGHTABILITY_MAPS)
  decideSituationAssessmentAgentRelatedUpdate(HUMAN1_MA);
  //ASA do not work for robot
// #if defined(JIDO)
//   decideSituationAssessmentAgentRelatedUpdate(JIDO_MA);
// #endif
// #if defined(PR2)
//   decideSituationAssessmentAgentRelatedUpdate(PR2_MA);
// #endif
#endif

  hri_manage_object_disappearance_and_move(gAgents, gEntities,gAgents->source_agent_idx );
  hri_compute_geometric_facts(gAgents, gEntities,gAgents->source_agent_idx);
#if defined(USE_MIGHTABILITY_MAPS)
  feedVisReachVisualisationStruct(HUMAN1_MA);
  //feedVisReachVisualisationStruct(JIDO_MA);
#endif
#ifdef ORO
  clearFacts(); 
  prepareFactsForORO(gAgents, gEntities);
#if defined(USE_MIGHTABILITY_MAPS)
  prepareAgentsActivityFactsForORO(gAgents,Ag_Activity_Fact,HUMAN1_MA);
#endif
  sendToORO(SDI_F->oroServerAddress.address, SDI_F->oroServerAddress.port);
#endif
  
  //elapsed_time = (clock() - clock_val)/CLOCKS_PER_SEC;
  //printf("TIME passed for: %f overall,\n", elapsed_time);
  
  return EXEC;
}


/* sparkComputeFactsEnd  -  codel END of ComputeFacts
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsEnd(int *report)
{
  return ETHER;
}


/* sparkComputeFactsInter  -  codel INTER of ComputeFacts
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkComputeFactsInter(int *report)
{
  return ETHER;
}

/* ------------------------------------------------------------- */
/* ---------  Manage Spheres Monitor Poster  ------------------- */
/* ------------------------------------------------------------- */

void publishSpheresMonitorPoster( void )
{ 
  sparkMonitoringSpheresmonitoringSpheresPosterWrite(SPARK_MONITORINGSPHERES_POSTER_ID, &SDI_F->monitoringSpheres);
}

static int updateSpheresMonitorPoster( void )
{
  int i;
  int iterModif = 0;
  if(gSpheres->modifIndex != SDI_F->monitoringSpheres.modifIndex){
    SDI_F->monitoringSpheres.modifIndex = gSpheres->modifIndex;
    //Reinit all spheres modifIndex if > 100
    if(gSpheres->modifIndex > 100)
      gSpheres->modifIndex = 0;

    for(i=0; i<SPARK_NUM_SPHERES_MAX; i++) {
      if(gSpheres->spheres[i]->modifIndex != SDI_F->monitoringSpheres.spheres[i].modifIndex){
	//Reinit sphere modifIndex if > 100
	if(gSpheres->spheres[i]->modifIndex > 100)
	  gSpheres->spheres[i]->modifIndex = 0;
	iterModif++;
	SDI_F->monitoringSpheres.spheres[i].modifIndex = gSpheres->spheres[i]->modifIndex;

	SDI_F->monitoringSpheres.spheres[i].isSphereActive = gSpheres->spheres[i]->isSphereActive;
	strcpy(SDI_F->monitoringSpheres.spheres[i].agentName.name, gSpheres->spheres[i]->agentName);
	SDI_F->monitoringSpheres.spheres[i].agentIndex = gSpheres->spheres[i]->agentIndex;
	strcpy(SDI_F->monitoringSpheres.spheres[i].objectName.name, gSpheres->spheres[i]->objectName);

	SDI_F->monitoringSpheres.spheres[i].entityIndex = gSpheres->spheres[i]->entityIndex;
	SDI_F->monitoringSpheres.spheres[i].handIndexInput = gSpheres->spheres[i]->handIndexInput;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.x = gSpheres->spheres[i]->sphereCenterX;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.y = gSpheres->spheres[i]->sphereCenterY;
	SDI_F->monitoringSpheres.spheres[i].sphereCenter.z = gSpheres->spheres[i]->sphereCenterZ;
	SDI_F->monitoringSpheres.spheres[i].sphereRadius = gSpheres->spheres[i]->sphereRadius;
	SDI_F->monitoringSpheres.spheres[i].sphereType = (SPARK_SPHERE_TYPE) gSpheres->spheres[i]->sphereType;
	SDI_F->monitoringSpheres.spheres[i].monitorEnterInResult = gSpheres->spheres[i]->monitorEnterInResult;
	SDI_F->monitoringSpheres.spheres[i].monitorGetOutResult = gSpheres->spheres[i]->monitorGetOutResult;
	SDI_F->monitoringSpheres.spheres[i].handIndexResult = gSpheres->spheres[i]->handIndexResult;
	SDI_F->monitoringSpheres.spheres[i].filteringTimeThreshold = gSpheres->spheres[i]->filteringTimeThreshold;
      }
    }
  }
  if(iterModif > 0)
    publishSpheresMonitorPoster();

  return TRUE;  
}

/* ------------------------------------------------------------- */
/* ----------------------- Test Sphere Monitors ---------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkTestSphereMonitorStart(int *report)
{
  if(!initSpheresIsDone){  
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);   
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkTestSphereMonitorMain(int *report)
{
  hriTestMonitor(gAgents, gEntities,gSpheres,SPARK_NUM_SPHERES_MAX,0);
  updateSpheresMonitorPoster();
  return EXEC;
}

/* ------------------------------------------------------------- */
/* ----------------------- Update Sphere Monitors -------------- */
/* ------------------------------------------------------------- */

ACTIVITY_EVENT
sparkUpdateSphereMonitorStart(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput,int *report)
{
  if(!initSpheresIsDone){  
    gSpheres = hri_create_spheres(SPARK_NUM_SPHERES_MAX);   
    initSpheresIsDone = true;
  }
  return EXEC;
}

ACTIVITY_EVENT
sparkUpdateSphereMonitorMain(SPARK_ACTION_MONITORING_SPHERE_INPUT_PARAMS *monitoringSphereInput, int *report)
{
  int e_j,e_k,a_i;
  GEN_STRING64 inferrenceObjectOrAgentPartName;


  if(monitoringSphereInput->monitorIndex >= SPARK_NUM_SPHERES_MAX){
    *report = S_spark_SPHERE_INDEX_TOO_BIG;
    return ETHER;
  }

  // Get Object index in entity array
  for(e_j=0; e_j<gEntities->entities_nb; e_j++) {
    if (!strcmp(monitoringSphereInput->objectName.name, gEntities->entities[e_j]->robotPt->name)){
      break;
    }
  }  
  if( e_j == gEntities->entities_nb) {
    *report = S_spark_OBJECT_NOT_FOUND;
    return ETHER;
  }

  
  // Get Agent index in agent array 
  for(a_i=0; a_i<gAgents->all_agents_no; a_i++){
    if (!strcmp(monitoringSphereInput->agentName.name, gAgents->all_agents[a_i]->robotPt->name)){  	  break;
    }
  }    

  if(a_i == gAgents->all_agents_no){
    *report = S_spark_AGENT_NOT_FOUND;
    return ETHER;
  }

  if(monitoringSphereInput->handIndexInput >= gAgents->all_agents[a_i]->hand_nb){
    *report = S_spark_AGENT_HAND_INDEX_TOO_BIG;
    return ETHER;
  }  

  hriUpdateSphereInSpheres(gAgents, gEntities, gSpheres ,SPARK_NUM_SPHERES_MAX, monitoringSphereInput->monitorIndex, monitoringSphereInput->activateSphere, monitoringSphereInput->agentName.name, a_i, monitoringSphereInput->objectName.name,e_j, monitoringSphereInput->sphereCenter.x,monitoringSphereInput->sphereCenter.y,monitoringSphereInput->sphereCenter.z , monitoringSphereInput->sphereRadius, monitoringSphereInput->sphereRadiusMultiply, monitoringSphereInput->sphereCenterTranslationMultiply , monitoringSphereInput->filteringTimeThreshold, (HRI_SPHERE_TYPE) monitoringSphereInput->sphereType);
    return ETHER;
}

#if defined(USE_MIGHTABILITY_MAPS)


/* Mightability Analyses Codels */
ACTIVITY_EVENT
sparkInit_MightabilityStart(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkInit_MightabilityMain(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{
 
 Create_and_init_Mightability_Maps(MM_around_obj->around_obj_name);
 
 SDI_F->state.mightabilitiesEnabled=1;
 printf(">>>>> After Create_and_init_Mightability_Maps(), SDI_F->state.mightabilitiesEnabled=%d\n",SDI_F->state.mightabilitiesEnabled);
 return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityInter(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkInit_MightabilityEnd(STRUCT_AROUND_OBJ_INFO_FOR_MM *MM_around_obj,int *report)
{

 return ETHER;
}

//To Update Mightabilities
ACTIVITY_EVENT
sparkUpdate_MightabilityStart(int *report)
{
 if(SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED==1)
 {
 SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=0;//Set to false
 return EXEC;
 }
 else
 {
 printf(" Mightability Analysis is NOT Initialized so Mightability will not be updated\n");
  return END;
 }
}

ACTIVITY_EVENT
sparkUpdate_MightabilityMain(int *report)
{
 if(SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE==0)
 {

  execute_Mightability_Map_functions();
  return EXEC;
 }

 if(SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE==1)
 {
  return END;
 }
 
 return EXEC;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkUpdate_MightabilityEnd(int *report)
{
 printf(" Existing from Update_Mightability loop, you need to call this request again to restart the loop \n"); 
 return ETHER;
}

//To SET the flags related to Update Mightabilities
ACTIVITY_EVENT
sparkSet_Mightability_flagsStart(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
 return EXEC;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsMain(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
 printf(" Mightability Flags are set : SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED=%d,  SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE=%d, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE=%d\n", SDI_F->MA_FLAGS.MIGHTABILITY_INITIALISED, SDI_F->MA_FLAGS.SATRT_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.STOP_MIGHTABILITY_UPDATE, SDI_F->MA_FLAGS.PAUSE_MIGHTABILITY_UPDATE);
 return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsInter(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkSet_Mightability_flagsEnd(STRUCT_MIGHTABILITY_FLAGS *MA_FLAGS, int *report)
{
 
 return ETHER;
}

//// Agent State Analysis Codels

//Init Agen State Analysis
ACTIVITY_EVENT
sparkInitAgentStateAnalysisStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisMain(int *report)
{
 init_agents_for_MA_and_ASA();

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);
  
  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  prepare_for_Agent_State_Analysis(threshold_file_path);
 return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkInitAgentStateAnalysisEnd(int *report)
{

 return ETHER;
}

//Reload Threshold for Agent State Analysis
ACTIVITY_EVENT
sparkReloadThresholdForASAStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAMain(int *report)
{

  char threshold_file_path[150];
  char *home_dir=getenv("HOME");
  printf(" Home directory is %s\n",home_dir);
  strcpy(threshold_file_path,home_dir);
  char threshold_file_name[50]="/Human_State_Analysis_Thresholds.txt";
  strcat(threshold_file_path,threshold_file_name);
  
  //"/home/akpandey/Human_State_Analysis_Thresholds.txt";
  init_thresholds_for_ASA(threshold_file_path);
 return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkReloadThresholdForASAEnd(int *report)
{

 return ETHER;
}


//StartAgentStateAnalysis
ACTIVITY_EVENT
sparkStartAgentStateAnalysisStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisMain(int *report)
{

if(STOP_AGENT_STATE_ANALYSIS==1)
{
  printf(" STOP Agent State Analysis\n");
    STOP_AGENT_STATE_ANALYSIS=0;
   return END;
 }
 if ( (NewDataForASA==1) || (NewDataForASA==4)) {
    hri_execute_Agent_State_Analysis_functions();
    if (NewDataForASA==4)
      NewDataForASA=3;
 }
 return EXEC;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkStartAgentStateAnalysisEnd(int *report)
{

 return ETHER;
}

//StopAgentStateAnalysis

ACTIVITY_EVENT
sparkStopAgentStateAnalysisStart(int *report)
{
 STOP_AGENT_STATE_ANALYSIS=1;
 return EXEC;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisMain(int *report)
{
 
 return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkStopAgentStateAnalysisEnd(int *report)
{

 return ETHER;
}

int printAgentsActivityFacts(int for_agent)
{

  printf(" ========= Status for agent %s =======\n",gEnv->robot[Ag_Activity_Fact[HUMAN1_MA].agent_index]->name);

  printf(" Whole Body : %d \n",Ag_Activity_Fact[for_agent].whole_body);
  printf(" Torso: %d \n",Ag_Activity_Fact[for_agent].torso);
  printf(" Head: %d \n",Ag_Activity_Fact[for_agent].head);
    
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand);
  printf(" Right Hand: %d \n",Ag_Activity_Fact[for_agent].right_hand_mode);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand);
  printf(" Left Hnad: %d \n",Ag_Activity_Fact[for_agent].left_hand_mode); 
}


ACTIVITY_EVENT
sparkPrintAgentStateAnalysisStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisMain(int *report)
{
if(PRINT_AGENT_STATE_FACTS==1)
  {
  PRINT_AGENT_STATE_FACTS=0;
  }
 else
  {
   PRINT_AGENT_STATE_FACTS=1;
  }
 
 ////printAgentsActivityFacts(HUMAN1_MA);
 return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkPrintAgentStateAnalysisEnd(int *report)
{

 return ETHER;
}


//// To get the human facts by name
int get_human_facts_in(Agent_Activity_fact_by_names &Hum_facts_by_name, STRUCT_AGENT_ACTIVITY_FACTS *hum_activity_fact)
{
  strcpy(hum_activity_fact->agent_name,Hum_facts_by_name.agent_name);
 strcpy(hum_activity_fact->agent_motion,Hum_facts_by_name.agent_motion);
 strcpy(hum_activity_fact->body_turn,Hum_facts_by_name.body_turn);
 strcpy(hum_activity_fact->torso_turn,Hum_facts_by_name.torso_turn);
strcpy(hum_activity_fact->head_turn,Hum_facts_by_name.head_turn);
strcpy(hum_activity_fact->right_hand_status,Hum_facts_by_name.right_hand_status);
strcpy(hum_activity_fact->right_hand_config_mode,Hum_facts_by_name.right_hand_config_mode);
strcpy(hum_activity_fact->right_hand_occup_mode,Hum_facts_by_name.right_hand_occup_mode);
strcpy(hum_activity_fact->right_hand_rest_mode_type,Hum_facts_by_name.right_hand_rest_mode_type);
strcpy(hum_activity_fact->right_hand_on_support,Hum_facts_by_name.right_hand_on_support);
strcpy(hum_activity_fact->right_hand_holding_object,Hum_facts_by_name.right_hand_holding_object);
strcpy(hum_activity_fact->left_hand_status,Hum_facts_by_name.left_hand_status);
strcpy(hum_activity_fact->left_hand_config_mode,Hum_facts_by_name.left_hand_config_mode);
strcpy(hum_activity_fact->left_hand_occup_mode,Hum_facts_by_name.left_hand_occup_mode);
strcpy(hum_activity_fact->left_hand_rest_mode_type,Hum_facts_by_name.left_hand_rest_mode_type);
strcpy(hum_activity_fact->left_hand_on_support,Hum_facts_by_name.left_hand_on_support);
strcpy(hum_activity_fact->left_hand_holding_object,Hum_facts_by_name.left_hand_holding_object);

}

ACTIVITY_EVENT
sparkGetHumanFactsByNameStart(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact, int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameMain(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{
 
 get_human_facts_in(Hum_facts_by_name[HUMAN1_MA],&hum_activity_fact->Agent_Facts[HUMAN1_MA]);

#ifdef HUMAN2_EXISTS_FOR_MA
 get_human_facts_in(Hum_facts_by_name[HUMAN2_MA],&hum_activity_fact->Agent_Facts[HUMAN2_MA]);
#endif
return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameInter(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkGetHumanFactsByNameEnd(STRUCT_AGENTS_ACTIVITY_FACTS *hum_activity_fact,int *report)
{

 return ETHER;
}

//Codels related to show object facts

//StartShowObjectFacts
ACTIVITY_EVENT
sparkStartShowObjectFactsStart(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
 return EXEC;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsMain(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
 printf(" Inside sparkStartShowObjectFactsMain with flag: SDI_F->show_obj_fact_flag.show_arrow=%d  \n", SDI_F->show_obj_fact_flag.show_arrow);
 SHOW_OBJ_FACTS_BY_ARROW=SDI_F->show_obj_fact_flag.show_arrow;
 SHOW_OBJECT_FACTS=1;
 return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsInter(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkStartShowObjectFactsEnd(STRUCT_SHOW_OBJECT_FACTS_FLAGS *show_obj_fact_flag, int *report)
{
 
 return ETHER;
}
 
//ResetShowObjectFactsData
ACTIVITY_EVENT
sparkResetShowObjectFactsDataStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataMain(int *report)
{
  init_object_facts_data();
  printf(" ... Done   init_object_facts_data()\n");
  return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataInter(int *report)
{

 return END;
}

ACTIVITY_EVENT
sparkResetShowObjectFactsDataEnd(int *report)
{

 return ETHER;
}

//StopShowObjectFacts
ACTIVITY_EVENT
sparkStopShowObjectFactsStart(int *report)
{
 
 return EXEC;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsMain(int *report)
{
 SHOW_OBJECT_FACTS=0;
 return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsInter(int *report)
{
 return END;
}

ACTIVITY_EVENT
sparkStopShowObjectFactsEnd(int *report)
{
 return ETHER;
}

#endif
